//
//  compiler.h
//  Yon
//
//  Created by Miso on 12.8.2009.
//  Copyright 2009 Miso Antonic. All rights reserved.
//
//

#ifndef COMPILER_H
#define COMPILER_H

#include "common.h"
#include "string.h"
#include "compiler_types.h"

struct Error
{
    SourcePosition position;
    wstring description;
    Error(wstring, SourcePosition);
    ~Error();
};
typedef Error* ErrorRef;

ErrorRef errorNew(wstring s, SourcePosition position);

struct Machine;
typedef Machine* MachineRef;

struct Compiler
{
    CHAR* compiledVersion;
    
    MachineRef machine;
    ErrorRef error;
    Compiler(MachineRef);
    ~Compiler();
};
typedef Compiler* CompilerRef;


CompilerRef compilerNew(const char* path);

void compilerRun(CompilerRef compiler, const wstring& source, const wstring& sourceName, const wstring& directory, const wstring& library);

bool compilerGetResult(CompilerRef compiler, BYTE** data, ULONG* dataSize);
bool compilerSaveResultToFile(CompilerRef compiler, const char* path);
bool compilerSaveResultWithVersionedFileNameToPath(CompilerRef compiler, const char* path);


#endif /* COMPILER_H */