//
//  compiler_types.cpp
//  Yon
//
//  Created by Miso on 22.8.2010.
//  Copyright (c) 2010 Miso Antonic. All rights reserved.
//

#include "compiler_types.h"

#include "common.h"

#include <iostream>


void addInfoForBytecode(BytecodeInfo** bytecodeInfos, ULONG* bytecodeInfoCount, ULONG index, SourcePosition position, ULONG indent)
{
	++(*bytecodeInfoCount);
	
	if (*bytecodeInfos == NULL)
		NEW_ARRAY(*bytecodeInfos, BytecodeInfo, *bytecodeInfoCount)
    else
        REALLOC_ARRAY(*bytecodeInfos, BytecodeInfo, *bytecodeInfoCount);
	
	BytecodeInfoRef info = &((*bytecodeInfos)[*bytecodeInfoCount-1]);
	info->index = index;
	info->position = position;
	info->indent = indent;
    info->profilerHit = 0;
    info->alreadyHit = false;
}

void unregisterHits(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount)
{
    ULONG i=0;
	for (i=0; i<bytecodeInfoCount; i++)
		bytecodeInfos[i].alreadyHit = false;
}

void hitBytecode(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG index)
{
    ULONG i=0;
	for (i=0; i<bytecodeInfoCount; i++)
		if (bytecodeInfos[i].index == index && !bytecodeInfos[i].alreadyHit)
        {
            ++bytecodeInfos[i].profilerHit;
            bytecodeInfos[i].alreadyHit = true;
        }
}

bool infoForBytecode(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG index, BytecodeInfoRef info)
{
	ULONG i=0;
	for (i=0; i<bytecodeInfoCount; i++)
	{
		if (bytecodeInfos[i].index == index)
		{
			info->index = index;
			info->position = bytecodeInfos[i].position;
			info->indent = bytecodeInfos[i].indent;
            info->profilerHit = bytecodeInfos[i].profilerHit;
            info->alreadyHit = bytecodeInfos[i].alreadyHit;
			return true;
		}
	}
	return false;
}

void printProfilerStatistics(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG profilerHits)
{
    wprintf(L"PROFILE:");
    ULONG i=0;
    for (i=0; i<bytecodeInfoCount; i++)
    {
        printString(bytecodeInfos[i].position.toShortString());
        wprintf(L":%d\n", 100 * bytecodeInfos[i].profilerHit / profilerHits);
    }
}