//
//  compiler_types.h
//  Yon
//
//  Created by Miso on 22.8.2010.
//  Copyright (c) 2010 Miso Antonic. All rights reserved.
//

#ifndef COMPILER_TYPES_H
#define COMPILER_TYPES_H

#include "common.h"
#include "string.h"

#pragma pack(push, 8)
typedef struct BytecodeInfo
{
	ULONG index;
	SourcePosition position;
    ULONG profilerHit;
	ULONG indent;
    bool alreadyHit;
    bool unused[7];
} BytecodeInfo;
typedef BytecodeInfo* BytecodeInfoRef;
#pragma pack(pop)

void addInfoForBytecode(BytecodeInfo** bytecodeInfos, ULONG* bytecodeInfoCount, ULONG index, SourcePosition position, ULONG indent);
void unregisterHits(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount);
void hitBytecode(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG index);
bool infoForBytecode(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG index, BytecodeInfoRef info);
void printProfilerStatistics(BytecodeInfo* bytecodeInfos, ULONG bytecodeInfoCount, ULONG profilerHits);

#endif /* COMPILER_TYPES_H */