//
//  language.h
//  Yon
//
//  Created by Miso on 6.8.2009.
//  Copyright 2009 Miso Antonic. All rights reserved.
//
//

#ifndef LANGUAGE_H
#define LANGUAGE_H

typedef enum 
{
	CALL_TYPE_TRANSPARENT = 0, CALL_TYPE_RETURNABLE = 1, 
	CALL_TYPE_BREAKABLE = 2, CALL_TYPE_CONTINUEABLE = 3
} CallType;


typedef enum
{
	bDONE = 0, 
    bINITIALIZE = 1, 
    
	bNUMBER = 10, 
    bSTRING = 11, 
    bSELF = 12, 
    bSELF_FOR_CALL = 13, 
    bLIST = 14, 
    bNIL = 15, 
    bPROPERTY = 16, 
    bNULL = 17,
	bCACHEDNUMBER = 18, 
	
	bPOP = 30, 
    bPOP_NON_TOP = 31, 
	bJUMP = 32, 
    bJUMPNO = 33, 
    bJUMPNO_NIL = 34, 
    bJUMP_FROZEN_POP = 35,     // back-jumps (with negative offset) must be used in a way that needed function stack count remains predictable
	
	bCAPTURE = 50, bRESTORE = 51, bRESTORE_FROM = 52,
	
	bBEGIN = 60, 
    bEND = 61,
	bVAR = 62, 
    bSLOT = 63, 
    bNATIVE = 64, 
	
	bNOT = 70,
    bAND = 71,
    bOR = 72,
	
	bPLUS = 73, 
    bUNARYPLUS = 74,
	bMINUS = 75,
    bUNARYMINUS = 76,
	bTIMES = 77,
	bDIVIDE = 78,
    bDIV = 79,
    bMOD = 80,
	bEXP = 81,
    
    bPLUS_CONST = 82,
    bMINUS_CONST = 83,
	bLESS = 84,
    bMORE = 85,
    bLESSOREQUAL = 86,
    bMOREOREQUAL = 87, 
	
	bASSIGN = 100, 
    bASSIGNIN = 101,
    bASSIGN_SLOT = 102, // Needed to override the priority of local vars over self slots
	
	
	
	bFIND = 110,
    bFINDIN = 111, 
    bFIND_FOR_CALL = 112, 
    bFINDIN_FOR_CALL = 113,

	bFIND_OPT = 114,
	bFIND_FOR_CALL_OPT = 115, 
    
	bCALL = 120, 
    bTAILCALL = 121,
	
	bRETURN = 130, 
    bYIELD = 131, 
    bRETURNFROM = 132, 
    bYIELDFROM = 133,
	
	bPRINT = 150, 
    bASSERT = 151
} ByteCode;

#endif /* LANGUAGE_H */